--[[	Spydon Communications Library
	by SDPhantom
	http://www.phantomweb.org	]]
------------------------------------------

local Name,Addon=...;
Addon.MessageCache={};
Addon.PrefixCallStack={};

local StackLen=65536;
local PlayerName=UnitName("player");

--------------------------
--[[	Event Hook	]]
--------------------------
Addon.RegisterEvent(
	function(func,event,pre,msg,chan,sender)
		local dat={time(),sender:match("^[^%-]*")==PlayerName and "ECHO" or "IN",Addon.PrefixCallStack[pre] or false,pre,msg,chan,sender};
		table.insert(Addon.MessageCache,dat);
		Addon.FireEvent("SPYDON_MESSAGELIST_UPDATE",unpack(dat));
	end
	,"CHAT_MSG_ADDON"
);

--------------------------
--[[	Helper Objects	]]
--------------------------
local function FormatToMsgString(val)--	String conversion function
	local vtype=type(val);
	return vtype=="string" and val or (vtype=="number" and tostring(val) or "");
end

local ChanReqTarget={--	Table for SendAddonMessage()
	WHISPER=true;
	PARTY=false;
	RAID=false;
	BATTLEGROUND=false;
	GUILD=false;
};

--------------------------
--[[	Function Hooks	]]
--------------------------
hooksecurefunc("RegisterAddonMessagePrefix",function(pre)
	if type(pre)=="string" and IsAddonMessagePrefixRegistered(pre) then
		local stack=debugstack(2,StackLen,0); repeat
			local rep; stack,rep=stack:gsub("^%[C%]:.-\n","");
		until rep<=0;

		Addon.PrefixCallStack[pre]=stack;
		Addon.FireEvent("SPYDON_PREFIX_ADDED",pre);
	end
end);

hooksecurefunc("SendAddonMessage",function(pre,msg,chan,target)
	------------------------------------------
	--[[	SendAddonMessage Error Handling	]]
	------------------------------------------
--	All numbers are converted to strings, all other non-strings convert to null string
--	This is done by the helper function, FormatToMsgString(val)

--	Error on prefix first (Length must be 1-16 chars)
	pre=FormatToMsgString(pre);	if #pre<=0 or #pre>16 then return; end

--	Error on invalid channel (Channels are converted to uppercase and checked against ChanReqTarget helper table)
	if type(chan)~="string" then return; else chan=chan:upper(); end
	local targetreq=ChanReqTarget[chan]; if targetreq==nil then return; end

--	Error on null target string
	target=targetreq and FormatToMsgString(target) or PlayerName; if targetreq and #target<=0 then return; end

--	No errors on message, but truncated to 255 chars
	msg=FormatToMsgString(msg):sub(1,255);




--	If we get here, the message was likely sent, log it if not filtered
	local stack=debugstack(2,StackLen,0); repeat
		local rep; stack,rep=stack:gsub("^%[C%]:.-\n","");
	until rep<=0;

	local dat={time(),"OUT",stack,pre,msg,chan,target};
	table.insert(Addon.MessageCache,dat);
	Addon.FireEvent("SPYDON_MESSAGELIST_UPDATE",unpack(dat));
end);
