--[[	Spydon Event Handler Library
	by SDPhantom
	http://www.phantomweb.org	]]
------------------------------------------

local Name,Addon=...;

--------------------------
--[[	Event Frame	]]
--------------------------
local EFrame=CreateFrame("Frame");
EFrame:SetScript("OnEvent",function(self,event,...)
	local ptr=self[event];
	if ptr then for i,j in ipairs(ptr) do j(j,event,...); end end
end);

Addon.EventFrame=EFrame;

--------------------------
--[[	API Functions	]]
--------------------------
function Addon.RegisterEvent(func,...)
	for i=1,select("#",...) do
		local event=tostring(select(i,...)):upper();
		local ptr=EFrame[event];
		if ptr then
			local found=false;
			for i,j in ipairs(ptr) do
				if j==func then
					found=true;
					break;
				end
			end
			if not found then table.insert(ptr,func); end
		else
			EFrame[event]={func};
			EFrame:RegisterEvent(event);
		end
	end
end

function Addon.UnregisterEvent(func,...)
	for i=1,select("#",...) do
		local event=tostring(select(i,...)):upper();
		local ptr=EFrame[event];
		if ptr then
			for i,j in ipairs(ptr) do
				if j==func then
					table.remove(EFrame,i);
					break;
				end
			end
			if #ptr<=0 then EFrame:UnregisterEvent(event); end
		end
	end
end

function Addon.FireEvent(event,...) return EFrame:GetScript("OnEvent")(EFrame,event,...); end
